#ifndef SiTCP_CNT_H
#define SiTCP_CNT_H

#include<iostream>

#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<unistd.h>
#include<errno.h>

#include<sys/types.h>
#include<sys/stat.h>
#include<sys/socket.h>
#include<sys/select.h>
#include<netinet/in.h>
#include<arpa/inet.h>

struct bcp_header{
  unsigned char type;
  unsigned char command;
  unsigned char id;
  unsigned char length;
  unsigned int address;
};

class SiTCP_Cnt{

 public:
  const char* sitcpIpAddr;
  unsigned int tcpPort;
  unsigned int udpPort;
  int udpsock;
  int tcpsock;
  struct sockaddr_in tcpAddr;
  struct sockaddr_in udpAddr;
  struct bcp_header sndHeader;
  //  unsigned int sndData[256];
  unsigned char sndData[256];
  unsigned char sndBuf[2048];
  fd_set rmask, wmask, fds, readfds;
  struct timeval timeout;
  unsigned short tmp[128][128];
    //short tmp[128][128];

  void RBCPskeleton(unsigned char type, unsigned char command, unsigned char id,
		    unsigned char length, unsigned char address);
  int rcvRBCP_ACK(int stdout);


  SiTCP_Cnt();
  ~SiTCP_Cnt();
  bool SetIPPort(const char* IpAddr, unsigned int tcp, unsigned int udp);
  bool CreateUDPSock();
  bool CloseUDPSock();
  bool CreateTCPSock();
  bool CloseTCPSock();

  int GetTCPSock(){return tcpsock;}
  int GetUDPSock(){return udpsock;}

};
#endif
